import { __assign } from "tslib";
import * as DWAnalyzer from '@antv/dw-analyzer';
/**
 * Return Data Properties of dataset.
 *
 * @public
 * @param data - dataset
 * @param fields - selected fields
 */
export function dataToDataProps(data, fields) {
    if (!data) {
        throw new Error('Argument `data` is missing.');
    }
    var dataTypeInfos = DWAnalyzer.typeAll(data, fields);
    var dataProps = [];
    dataTypeInfos.forEach(function (info) {
        var lom = [];
        if (DWAnalyzer.isNominal(info))
            lom.push('Nominal');
        if (DWAnalyzer.isOrdinal(info))
            lom.push('Ordinal');
        if (DWAnalyzer.isInterval(info))
            lom.push('Interval');
        if (DWAnalyzer.isDiscrete(info))
            lom.push('Discrete');
        if (DWAnalyzer.isContinuous(info))
            lom.push('Continuous');
        if (DWAnalyzer.isTime(info))
            lom.push('Time');
        var newInfo = __assign(__assign({}, info), { levelOfMeasurements: lom });
        dataProps.push(newInfo);
    });
    return dataProps;
}
