import { __assign, __awaiter, __generator } from "tslib";
/**
 * g2plot render function
 * @public
 */
export function g2plotRender(container, data, libConfigs) {
    return __awaiter(this, void 0, void 0, function () {
        var type, configs, containerDOM, G2Plot, plot;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    type = libConfigs.type, configs = libConfigs.configs;
                    containerDOM = typeof container === 'string' ? document.getElementById(container) : container;
                    if (!containerDOM)
                        return [2 /*return*/, null];
                    return [4 /*yield*/, import(/* webpackChunkName: "g2plot" */ '@antv/g2plot')];
                case 1:
                    G2Plot = _a.sent();
                    plot = new G2Plot[type](containerDOM, __assign({ data: data, height: containerDOM.clientHeight ? containerDOM.clientHeight : 300, autoFit: true }, configs));
                    plot.render();
                    return [2 /*return*/, plot];
            }
        });
    });
}
/**
 * g2 render function
 * @public
 */
export function g2Render(container, data, configs) {
    return __awaiter(this, void 0, void 0, function () {
        var g2plotIns;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, g2plotRender(container, data, configs)];
                case 1:
                    g2plotIns = _a.sent();
                    return [2 /*return*/, g2plotIns === null || g2plotIns === void 0 ? void 0 : g2plotIns.chart];
            }
        });
    });
}
