import { CLASS_PREFIX } from '../style';
import draggable from './draggable';
var DevPanel = /** @class */ (function () {
    function DevPanel(options) {
        var _this = this;
        /**
         * panel 的容器
         */
        this.containerEl = document.createElement('div');
        this.destroyed = false;
        this.options = options;
        var title = options.title, width = options.width, height = options.height, content = options.content, visible = options.visible, top = options.top, right = options.right;
        var containerEl = this.containerEl;
        this.visible = visible;
        var display = visible ? 'block' : 'none';
        containerEl.innerHTML = "\n    <div data-id=\"panel\" class=\"" + CLASS_PREFIX + "dev_panel\" style=\"height: " + height + "px; width: " + width + "px; display: " + display + "; top: " + (top +
            10) + "px; left: " + (right - width - 20) + "px;\">\n      <div data-id=\"mask\" class=\"" + CLASS_PREFIX + "dev_panel_mask\"></div>\n      <header>" + title + "<span data-id=\"close\" class=\"" + CLASS_PREFIX + "dev_panel_close\"><img style=\"width: 16px; height: 16px;\" src=\"https://gw.alipayobjects.com/zos/antfincdn/5mKWpRQ053/close.png\"/></span></header>\n      <div data-id=\"content\" class=\"" + CLASS_PREFIX + "dev_panel_content\"></div>\n    </div>\n    ";
        var panelEl = (this.panelEl = containerEl.querySelector('[data-id="panel"]'));
        var contentEl = (this.contentEl = containerEl.querySelector('[data-id="content"]'));
        if (typeof content === 'string')
            contentEl.innerHTML = content;
        else
            contentEl.appendChild(content);
        var closeEl = containerEl.querySelector('[data-id="close"]');
        closeEl.addEventListener('click', function () {
            _this.hide();
        });
        draggable(panelEl);
        document.body.appendChild(this.containerEl);
    }
    /**
     * 销毁实例
     */
    DevPanel.prototype.destroy = function () {
        var _a = this, destroyed = _a.destroyed, containerEl = _a.containerEl;
        if (destroyed)
            return;
        document.body.removeChild(containerEl);
        this.destroyed = true;
    };
    DevPanel.prototype.show = function () {
        this.panelEl.style.display = 'block';
        this.visible = true;
    };
    DevPanel.prototype.hide = function () {
        this.panelEl.style.display = 'none';
        this.visible = false;
    };
    DevPanel.prototype.toggle = function () {
        if (this.visible)
            this.hide();
        else
            this.show();
    };
    return DevPanel;
}());
export { DevPanel };
