import { __assign } from "tslib";
import { uuid } from '../util';
/**
 * @public
 */
var DummyPlot = /** @class */ (function () {
    function DummyPlot(container, data, config) {
        this.uuid = uuid();
        this.container = container;
        this.config = config;
        this.data = data;
        this.render();
    }
    DummyPlot.prototype.render = function () {
        var _this = this;
        var _a = this, config = _a.config, container = _a.container, data = _a.data;
        var type = config.type, configs = config.configs;
        this.currentConfigs = __assign(__assign({}, configs), { data: data });
        this.type = type;
        try {
            // @ts-ignore
            import(/* webpackChunkName: "g2plot" */ '@antv/g2plot').then(function (G2Plot) {
                // @ts-ignore
                _this.plot = new G2Plot[type](container, __assign(__assign({}, configs), { data: data }));
                _this.plot.render();
            });
        }
        catch (e) {
            throw new Error('current config is not supported by g2plot');
        }
    };
    DummyPlot.prototype.destroy = function () {
        if (this.plot && !this.plot.destroyed) {
            this.plot.destroy();
        }
    };
    return DummyPlot;
}());
export { DummyPlot };
