import { CLASS_PREFIX } from '../style';
import { intl } from '../i18n';
var EmptyContent = /** @class */ (function () {
    function EmptyContent(container) {
        this.rendered = false;
        this.destroyed = false;
        this.chartContainer = container;
        this.content = document.createElement('div');
        this.content.className = CLASS_PREFIX + "no_data_content";
    }
    EmptyContent.prototype.render = function () {
        this.rendered = true;
        this.content.innerHTML = "\n      <div style=\"margin-bottom: 16px;\">\n        <img src=\"https://gw.alipayobjects.com/zos/basement_prod/9a59280d-8f23-4234-b5cf-02956a91b6ff.svg\" />\n      </div>\n      <div>" + intl.get('No Data') + "</div>\n    ";
        this.chartContainer.appendChild(this.content);
    };
    EmptyContent.prototype.destroy = function (_container) {
        var _a = this, rendered = _a.rendered, destroyed = _a.destroyed, chartContainer = _a.chartContainer, content = _a.content;
        if (!rendered || destroyed)
            return;
        chartContainer.removeChild(content);
        this.destroyed = true;
    };
    return EmptyContent;
}());
export { EmptyContent };
