import { __values } from "tslib";
import { removeAllChild } from '../util';
import { CLASS_PREFIX } from '../style';
function generateCard(name, value) {
    var cardDom = document.createElement('div');
    cardDom.className = CLASS_PREFIX + "kpi-panel-card";
    var nameDom = document.createElement('div');
    nameDom.className = CLASS_PREFIX + "kpi-panel-card-name";
    cardDom.appendChild(nameDom);
    nameDom.innerText = name;
    var valueDOm = document.createElement('div');
    valueDOm.className = CLASS_PREFIX + "kpi-panel-card-value";
    valueDOm.innerText = value;
    cardDom.appendChild(valueDOm);
    return cardDom;
}
/**
 *  custom render kpi panel
 */
var KPIPlot = /** @class */ (function () {
    function KPIPlot(container, data) {
        this.container = container;
        this.data = data;
    }
    KPIPlot.prototype.render = function () {
        var e_1, _a;
        this.destroy();
        var wrapper = document.createElement('div');
        wrapper.className = CLASS_PREFIX + "kpi-panel";
        try {
            for (var _b = __values(Object.keys(this.data)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var key = _c.value;
                wrapper.appendChild(generateCard(key, this.data[key]));
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        this.container.appendChild(wrapper);
    };
    KPIPlot.prototype.update = function () { };
    KPIPlot.prototype.destroy = function () {
        removeAllChild(this.container);
    };
    return KPIPlot;
}());
export { KPIPlot };
