import { __values } from "tslib";
import { removeAllChild } from '../util';
import { CLASS_PREFIX } from '../style';
import { intl } from '../i18n';
var Table = /** @class */ (function () {
    function Table(container, data) {
        this.container = container;
        this.data = data;
    }
    Table.prototype.render = function () {
        var e_1, _a, e_2, _b, e_3, _c;
        this.destroy();
        if (this.data.length > 0) {
            if (this.data.length < 100) {
                var keys = Object.keys(this.data[0]);
                var tableDom = document.createElement('table');
                tableDom.className = CLASS_PREFIX + "-table";
                // table head
                var thead = document.createElement('thead');
                var thead_tr = document.createElement('tr');
                try {
                    for (var keys_1 = __values(keys), keys_1_1 = keys_1.next(); !keys_1_1.done; keys_1_1 = keys_1.next()) {
                        var key = keys_1_1.value;
                        var th = document.createElement('th');
                        th.innerText = key;
                        thead_tr.appendChild(th);
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (keys_1_1 && !keys_1_1.done && (_a = keys_1.return)) _a.call(keys_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                thead.appendChild(thead_tr);
                // table body
                var tbody = document.createElement('tbody');
                try {
                    for (var _d = __values(this.data), _e = _d.next(); !_e.done; _e = _d.next()) {
                        var item = _e.value;
                        var tbody_tr = document.createElement('tr');
                        try {
                            for (var keys_2 = (e_3 = void 0, __values(keys)), keys_2_1 = keys_2.next(); !keys_2_1.done; keys_2_1 = keys_2.next()) {
                                var key = keys_2_1.value;
                                var td = document.createElement('td');
                                td.innerText = item[key];
                                tbody_tr.appendChild(td);
                            }
                        }
                        catch (e_3_1) { e_3 = { error: e_3_1 }; }
                        finally {
                            try {
                                if (keys_2_1 && !keys_2_1.done && (_c = keys_2.return)) _c.call(keys_2);
                            }
                            finally { if (e_3) throw e_3.error; }
                        }
                        tbody.appendChild(tbody_tr);
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_e && !_e.done && (_b = _d.return)) _b.call(_d);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
                tableDom.appendChild(thead);
                tableDom.appendChild(tbody);
                this.container.appendChild(tableDom);
            }
            else {
                this.container.innerText = intl.get('The data is too big to support temporarily');
            }
        }
    };
    Table.prototype.update = function () { };
    Table.prototype.destroy = function () {
        removeAllChild(this.container);
    };
    return Table;
}());
export { Table };
