import { en_US, zh_CN } from './locales';
import { get as _get } from 'lodash';
var defaultLanguage = undefined;
var transformLanguage = function (language) {
    // If the language starts with "zh", it is "zh-CN" by default,
    if (language && language === 'zh-CN')
        return language;
    // otherwise, it will be "en_US".
    return 'en-US';
};
export var getLanguage = function () {
    if (defaultLanguage)
        return defaultLanguage;
    return transformLanguage(navigator.language);
};
// set the default language
export var setLanguage = function (language) {
    defaultLanguage = language === 'zh-CN' || 'en-US' ? language : transformLanguage(navigator.language);
};
export var intl = {
    get: function (key, language) {
        return _get({ en_US: en_US, zh_CN: zh_CN }, [language ? transformLanguage(language).replace('-', '_') : getLanguage().replace('-', '_'), key], key);
    },
};
