/**
 * 自动图表
 *
 * @example
 *
 * ```typescript
 *  const container = document.getElementById('mountNode');
 *  import { autoChart } from '@antv/chart-advisor';
 *
 *  const data = [
 *   {date: '2020/01/01', value: '666'},
 *   {date: '2020/01/02', value: '888'},
 *   ...
 *  ];
 *  autoChart(container, data);
 * ```
 *
 * @packageDocumentation
 */
import { __awaiter, __generator } from "tslib";
import { AutoChart } from './auto-chart/auto-chart';
/**
 * 自动图表
 * @param container - 容器
 * @param data - 数据
 * @param options - 配置
 * @public
 */
export function autoChart(container, data, options) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, AutoChart.create(container, data, options)];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
export { AutoChart };
export { AutoPlot } from './auto-chart/auto-plot';
export { DummyPlot } from './auto-chart/dummy-plot';
export * from './advice-pipeline';
export { initChartRules, CHART_RULE_ID, Rule, } from './rules';
export { insightsFromData, insightsFromDataset } from './insight';
export { INSIGHT_TYPES, insightWorkers } from './insight/insightWorkers';
