import { __awaiter, __generator } from "tslib";
import { Insight } from 'visual-insights';
import { rowDataToColumnFrame } from './insightWorkers/utils';
export var DefaultIWorker = Insight.DefaultIWorker;
export var workerCollection = Insight.IntentionWorkerCollection.init();
export var getInsightSpaces = function (props) {
    return __awaiter(this, void 0, void 0, function () {
        var dataSource, _fields, collection, _dimensions, _measures, _a, enableUniqueFields, fields, colFrame, dimensions, measures;
        return __generator(this, function (_b) {
            dataSource = props.dataSource, _fields = props.fields, collection = props.collection, _dimensions = props.dimensions, _measures = props.measures, _a = props.enableUniqueFields, enableUniqueFields = _a === void 0 ? true : _a;
            if (dataSource.length === 0)
                return [2 /*return*/, []];
            if (typeof _dimensions !== 'undefined' && typeof _measures !== 'undefined') {
                return [2 /*return*/, Insight.getVisSpaces({
                        dataSource: dataSource,
                        dimensions: _dimensions,
                        measures: _measures,
                        collection: collection,
                    })];
            }
            fields = typeof _fields === 'undefined' ? Object.keys(dataSource[0]) : _fields;
            colFrame = rowDataToColumnFrame(dataSource);
            dimensions = colFrame.columnProps
                .filter(function (col) { return col.title !== null && fields.includes(col.title); })
                .filter(function (col) { return !(col.type === 'integer' || col.type === 'float'); })
                .filter(function (col) { return enableUniqueFields || !col.isUnique; })
                .map(function (col) { return col.title; });
            measures = colFrame.columnProps
                .filter(function (col) { return col.title !== null && fields.includes(col.title); })
                .filter(function (col) { return col.type === 'integer' || col.type === 'float'; })
                .map(function (col) { return col.title; });
            return [2 /*return*/, Insight.getVisSpaces({
                    dataSource: dataSource,
                    dimensions: dimensions,
                    measures: measures,
                    collection: collection,
                })];
        });
    });
};
