import { __awaiter, __generator, __read, __spread } from "tslib";
import { Dataset } from '@antv/dw-transform';
import { insightWorkers } from './insightWorkers';
/**
 * @public
 */
export function insightsFromData(data) {
    return __awaiter(this, void 0, void 0, function () {
        var workers, allInsightsPack, allInsights;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    workers = Object.values(insightWorkers);
                    return [4 /*yield*/, Promise.all(workers.map(function (worker) { return worker(data); }))];
                case 1:
                    allInsightsPack = _a.sent();
                    allInsights = [];
                    allInsightsPack.forEach(function (insights) {
                        allInsights = allInsights.concat(__spread(insights));
                    });
                    return [2 /*return*/, allInsights];
            }
        });
    });
}
/**
 * @public
 */
export function insightsFromDataset(data, options) {
    return __awaiter(this, void 0, void 0, function () {
        var dataset, subDatasets, allInsightsPack, allInsights;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    dataset = new Dataset(data);
                    subDatasets = dataset.allSubspaceDataset(options);
                    return [4 /*yield*/, Promise.all(subDatasets.map(function (subDataset) { return insightsFromData(subDataset); }))];
                case 1:
                    allInsightsPack = _a.sent();
                    allInsights = [];
                    allInsightsPack.forEach(function (insights) {
                        allInsights = allInsights.concat(__spread(insights));
                    });
                    return [2 /*return*/, allInsights];
            }
        });
    });
}
