import { correlationIW } from './correlation';
import { monotonicityIW } from './monotonicity';
import { majorFactorsIW } from './major';
import { overallTrendsIW } from './overallTrends';
import { outlierIW } from './outlier';
import { trendIW as viTrendIW } from './vi-trend';
var tuple = function () {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    return args;
};
/**
 * @public
 */
export var INSIGHT_TYPES = tuple('Correlation', 'Monotonicity', 'MajorFactors', 'OverallTrends', 'CategoryOutliers', 
// todo...
'TimeSeriesOutliers', 'Seasonality', 'ChangePoints');
/**
 * @public
 */
export var insightWorkers = {
    Correlation: correlationIW,
    Monotonicity: monotonicityIW,
    MajorFactors: majorFactorsIW,
    OverallTrends: overallTrendsIW,
    CategoryOutliers: outlierIW,
};
export { correlationIW, viTrendIW, monotonicityIW, overallTrendsIW, outlierIW };
