import { rowDataToColumnFrame, columnsToRowData } from './utils';
export var majorFactorsIW = function (data) {
    var THRESHOLD = 0.6;
    var insights = [];
    var _a = rowDataToColumnFrame(data), columnProps = _a.columnProps, columns = _a.columns;
    var _loop_1 = function (i) {
        var fieldInfo = columnProps[i].fieldInfo;
        if (fieldInfo) {
            var valueMap_1 = fieldInfo.valueMap, countSum_1 = fieldInfo.count;
            if (valueMap_1 && countSum_1) {
                var maxCount_1 = -1;
                var maxKeys_1 = [];
                Object.keys(valueMap_1).forEach(function (key) {
                    var count = valueMap_1[key];
                    if (count >= maxCount_1) {
                        maxCount_1 = count;
                        maxKeys_1.push(key);
                    }
                });
                maxKeys_1.forEach(function (key) {
                    var count = valueMap_1[key];
                    if (count / countSum_1 >= THRESHOLD) {
                        var columnTitle = columnProps[i].title;
                        var countTitle = "COUNT(" + columnTitle + ")";
                        var presentData = columnsToRowData([Object.keys(valueMap_1), Object.values(valueMap_1)], [columnTitle, countTitle]);
                        var insight = {
                            type: 'MajorFactors',
                            description: "'" + key + "' occupies for the majority of '" + columnTitle + "' by " + (count / countSum_1) * 100 + "%",
                            fields: [columnTitle],
                            present: {
                                data: presentData,
                                fields: [columnTitle, countTitle],
                                purpose: ['Proportion'],
                                type: 'pie_chart',
                                encoding: {
                                    color: columnTitle,
                                    angle: countTitle,
                                },
                                configs: {
                                    xAxis: { title: { visible: true } },
                                    yAxis: { title: { visible: true } },
                                },
                            },
                        };
                        insights.push(insight);
                    }
                });
            }
        }
    };
    for (var i = 0; i < columns.length; i++) {
        _loop_1(i);
    }
    return insights;
};
