import { autoTransform } from '@antv/dw-transform';
import { rowDataToColumnFrame, columnsToRowData, isMonotonicDec, isMonotonicInc } from './utils';
export var monotonicityIW = function (data) {
    var insights = [];
    var _a = rowDataToColumnFrame(data), columnProps = _a.columnProps, columns = _a.columns;
    for (var i = 0; i < columns.length; i++) {
        // todo: isOrdinal w. sort
        if (columnProps[i].isTime) {
            var _loop_1 = function (j) {
                if (columnProps[j].isInterval) {
                    var dimensionTitle_1 = columnProps[i].title;
                    var measureTitle_1 = columnProps[j].title;
                    var subData_1 = columnsToRowData([columns[i], columns[j]], [dimensionTitle_1, measureTitle_1]);
                    if (subData_1) {
                        // AGGREGATION.forEach((aggType) => {
                        ['sum'].forEach(function (aggType) {
                            var aggData = autoTransform(subData_1, false, aggType).result;
                            aggData.sort(function (a, b) { return a[dimensionTitle_1] - b[dimensionTitle_1]; });
                            var sortedMeasureCol = aggData.map(function (row) { return row[measureTitle_1]; });
                            var direction = null;
                            if (isMonotonicInc(sortedMeasureCol)) {
                                direction = 'increase';
                            }
                            if (isMonotonicDec(sortedMeasureCol)) {
                                direction = 'decrease';
                            }
                            if (direction) {
                                var insight = {
                                    type: 'Monotonicity',
                                    description: "'" + measureTitle_1 + "' " + direction + "s monotonically with '" + dimensionTitle_1 + "'",
                                    fields: [dimensionTitle_1, measureTitle_1],
                                    insightProps: {
                                        dimensions: [dimensionTitle_1],
                                        measures: [measureTitle_1],
                                        score: 1,
                                        detail: {
                                            direction: direction,
                                        },
                                    },
                                    present: {
                                        purpose: ['Trend'],
                                        type: 'line_chart',
                                        data: subData_1,
                                        encoding: {
                                            x: dimensionTitle_1,
                                            y: measureTitle_1,
                                        },
                                        configs: { xAxis: { title: { visible: true } }, yAxis: { title: { visible: true } } },
                                    },
                                };
                                insights.push(insight);
                            }
                        });
                    }
                }
            };
            for (var j = 0; j < columns.length; j++) {
                _loop_1(j);
            }
        }
    }
    return insights;
};
