import { rowDataToColumnFrame, outliersFilters } from './utils';
export var outlierIW = function (data) {
    var insights = [];
    var _a = rowDataToColumnFrame(data), columnProps = _a.columnProps, columns = _a.columns;
    var dataProps = columnProps.map(function (cp) { return cp.fieldInfo; });
    var filters = outliersFilters(dataProps);
    var _loop_1 = function (i) {
        var _loop_2 = function (j) {
            if (columnProps[i].isInterval || columnProps[j].isInterval) {
                var hasInsight_1 = false;
                var dimensionTitle = void 0;
                var measureTitle = void 0;
                if (columnProps[i].isInterval) {
                    dimensionTitle = columnProps[j].title;
                    measureTitle = columnProps[i].title;
                }
                else {
                    dimensionTitle = columnProps[i].title;
                    measureTitle = columnProps[j].title;
                }
                var subdata = columns[i].map(function (valueI, index) {
                    var newRow = {};
                    newRow[columnProps[i].title] = valueI;
                    var valueJ = columns[j][index];
                    newRow[columnProps[j].title] = valueJ;
                    newRow.isOutlier =
                        (columnProps[i].isInterval && filters[i](valueI)) || (columnProps[j].isInterval && filters[j](valueJ));
                    if (newRow.isOutlier) {
                        hasInsight_1 = true;
                    }
                    return newRow;
                });
                if (hasInsight_1) {
                    var dimension_1 = '';
                    var measure = '';
                    if (columnProps[i].isInterval) {
                        dimension_1 = columnProps[j].title;
                        measure = columnProps[i].title;
                    }
                    else {
                        dimension_1 = columnProps[i].title;
                        measure = columnProps[j].title;
                    }
                    var outlierSeries = subdata.filter(function (row) { return row.isOutlier; }).map(function (row) { return row[dimension_1]; });
                    var outlierSeriesStr = '';
                    if (outlierSeries.length === 1) {
                        outlierSeriesStr = "'" + outlierSeries[0] + "'";
                    }
                    else {
                        for (var i_1 = 0; i_1 < outlierSeries.length; i_1++) {
                            if (i_1 === outlierSeries.length - 1) {
                                outlierSeriesStr += " and '" + outlierSeries[i_1] + "'";
                            }
                            else if (i_1 === 0) {
                                outlierSeriesStr += "'" + outlierSeries[i_1] + "'";
                            }
                            else {
                                outlierSeriesStr += ", '" + outlierSeries[i_1] + "'";
                            }
                        }
                    }
                    var description = outlierSeriesStr + " " + (outlierSeries.length === 1 ? 'is' : 'are') + " noticeable " + (outlierSeries.length === 1 ? 'outlier' : 'outliers') + " for '" + measure + "'";
                    var chartType = columnProps[i].isInterval && columnProps[j].isInterval ? 'scatter_plot' : 'column_chart';
                    var insight = {
                        type: 'CategoryOutliers',
                        description: description,
                        fields: [columnProps[i].title, columnProps[j].title],
                        present: {
                            data: subdata.map(function (row) {
                                row.isOutlier = row.isOutlier ? 'Outlier' : 'Not';
                                return row;
                            }),
                            fields: [columnProps[i].title, columnProps[j].title, 'isOutlier'],
                            purpose: ['Distribution'],
                            type: chartType,
                            encoding: {
                                x: dimensionTitle,
                                y: measureTitle,
                                color: 'isOutlier',
                            },
                            configs: {
                                xAxis: { title: { visible: true } },
                                yAxis: { title: { visible: true } },
                                color: ['#5B8FF9', '#ff99c3'],
                            },
                        },
                    };
                    insights.push(insight);
                }
            }
        };
        for (var j = i + 1; j < columns.length; j++) {
            _loop_2(j);
        }
    };
    for (var i = 0; i < columns.length; i++) {
        _loop_1(i);
    }
    return insights;
};
