import { CLASS_PREFIX } from './style';
import { G2PLOT_TYPE_MAPPING } from './advice-pipeline';
/**
 * 随机生成一个唯一ID
 */
export function uuid() {
    return "" + 'xxxx-xxxx-xxxx'.replace(/x/g, function () { return ((Math.random() * 16) | (0 & 0x3)).toString(16); });
}
export function getElementDisplay(item) {
    return getComputedStyle(item, null).display;
}
export function getPosition(target) {
    var _a = target.getBoundingClientRect(), top = _a.top, left = _a.left, right = _a.right;
    return {
        top: top + window.scrollY,
        left: left + window.scrollX,
        right: right + window.scrollX,
    };
}
/**
 * @deprecated
 * when config panel rebuild
 */
export function translate(term) {
    return G2PLOT_TYPE_MAPPING[term] || term;
}
export function createLayer(container, classname) {
    if (!['relative', 'absolute', 'fixed'].includes(getComputedStyle(container).position)) {
        container.style.position = 'relative';
    }
    var layer = document.createElement('div');
    layer.style.height = '100%';
    layer.style.width = '100%';
    layer.style.position = 'absolute';
    layer.style.top = '0px';
    layer.style.left = '0px';
    layer.style.pointerEvents = 'none';
    layer.style.boxSizing = 'border-box';
    if (classname)
        layer.className = classname;
    container.appendChild(layer);
    return layer;
}
export function DEFAULT_FEEDBACK(feedback) {
    return function fn(container) {
        var content = document.createElement('div');
        content.className = CLASS_PREFIX + "no_data_content";
        content.innerHTML = "\n    <div style=\"margin-bottom: 16px;\">\n      <img src=\"https://gw.alipayobjects.com/zos/basement_prod/9a59280d-8f23-4234-b5cf-02956a91b6ff.svg\" />\n    </div>\n    <div>" + feedback + "</div>\n  ";
        container.appendChild(content);
    };
}
/**
 * remove all children node in specific dom
 * @param dom HTMLElement
 */
export function removeAllChild(dom) {
    while (dom.firstChild) {
        dom.removeChild(dom.firstChild);
    }
}
