"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.g2Render = exports.g2plotRender = void 0;
var tslib_1 = require("tslib");
/**
 * g2plot render function
 * @public
 */
function g2plotRender(container, data, libConfigs) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var type, configs, containerDOM, G2Plot, plot;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    type = libConfigs.type, configs = libConfigs.configs;
                    containerDOM = typeof container === 'string' ? document.getElementById(container) : container;
                    if (!containerDOM)
                        return [2 /*return*/, null];
                    return [4 /*yield*/, Promise.resolve().then(function () { return tslib_1.__importStar(require(/* webpackChunkName: "g2plot" */ '@antv/g2plot')); })];
                case 1:
                    G2Plot = _a.sent();
                    plot = new G2Plot[type](containerDOM, tslib_1.__assign({ data: data, height: containerDOM.clientHeight ? containerDOM.clientHeight : 300, autoFit: true }, configs));
                    plot.render();
                    return [2 /*return*/, plot];
            }
        });
    });
}
exports.g2plotRender = g2plotRender;
/**
 * g2 render function
 * @public
 */
function g2Render(container, data, configs) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var g2plotIns;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, g2plotRender(container, data, configs)];
                case 1:
                    g2plotIns = _a.sent();
                    return [2 /*return*/, g2plotIns === null || g2plotIns === void 0 ? void 0 : g2plotIns.chart];
            }
        });
    });
}
exports.g2Render = g2Render;
