"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.specRender = exports.dataToAdvices = exports.G2PLOT_TYPE_MAPPING = exports.g2plotRender = exports.g2Render = exports.adviceToLibConfig = exports.dataPropsToAdvices = exports.dataToDataProps = void 0;
var tslib_1 = require("tslib");
// DO NOT remove this G2Plot import line, for the sake of api-extractor.
// https://github.com/microsoft/rushstack/issues/2140
// @ts-ignore
// eslint-disable-next-line @typescript-eslint/no-unused-vars
// import * as G2Plot from '@antv/g2plot';
var dw_util_1 = require("@antv/dw-util");
// step 1: data -> data props
var data_to_dataprops_1 = require("./data-to-dataprops");
Object.defineProperty(exports, "dataToDataProps", { enumerable: true, get: function () { return data_to_dataprops_1.dataToDataProps; } });
// step 2: data props -> vega lite specs
var dataprops_to_advices_1 = require("./dataprops-to-advices");
Object.defineProperty(exports, "dataPropsToAdvices", { enumerable: true, get: function () { return dataprops_to_advices_1.dataPropsToAdvices; } });
// step 3: vega lite spec -> lib config
// libconfig contain g2 g2plot, default g2plot
var spec_to_libconfig_1 = require("./spec-to-libconfig");
Object.defineProperty(exports, "adviceToLibConfig", { enumerable: true, get: function () { return spec_to_libconfig_1.adviceToLibConfig; } });
Object.defineProperty(exports, "G2PLOT_TYPE_MAPPING", { enumerable: true, get: function () { return spec_to_libconfig_1.G2PLOT_TYPE_MAPPING; } });
// step 4: lib config -> chart render & return instance
// `chart-advisor` support g2 and g2plot render
// you can also use vegalite spec config to render 🌟
var g2_render_1 = require("./g2-render");
Object.defineProperty(exports, "g2Render", { enumerable: true, get: function () { return g2_render_1.g2Render; } });
Object.defineProperty(exports, "g2plotRender", { enumerable: true, get: function () { return g2_render_1.g2plotRender; } });
tslib_1.__exportStar(require("./interface"), exports);
tslib_1.__exportStar(require("./vega-lite"), exports);
// step 1 + step 2
/**
 * @public
 */
function dataToAdvices(data, options) {
    var showLog = options === null || options === void 0 ? void 0 : options.showLog;
    if (showLog)
        console.log('💠💠💠💠💠💠 data 💠💠💠💠💠💠');
    if (showLog)
        console.log(data);
    if (showLog)
        console.log('🍯🍯🍯🍯🍯🍯 options 🍯🍯🍯🍯🍯🍯');
    if (showLog)
        console.log(options);
    var dataProps = data_to_dataprops_1.dataToDataProps(data, options === null || options === void 0 ? void 0 : options.fields);
    if (showLog)
        console.log('🔶🔶🔶🔶🔶🔶 dataset analysis 🔶🔶🔶🔶🔶🔶');
    if (showLog)
        console.log(dataProps);
    var dataset = new dw_util_1.Dataset('json', { source: data });
    var adviceList = dataprops_to_advices_1.dataPropsToAdvices(dataProps, options, dataset);
    return adviceList;
}
exports.dataToAdvices = dataToAdvices;
// step 3 + step 4
// default render as g2plot
/**
 * @public
 */
function specRender(container, data, spec, libraryName) {
    if (libraryName === void 0) { libraryName = 'G2Plot'; }
    var libconfig = spec_to_libconfig_1.adviceToLibConfig(spec, libraryName);
    if (!libconfig)
        return null;
    return libraryName === 'G2Plot' ? g2_render_1.g2plotRender(container, data, libconfig) : g2_render_1.g2Render(container, data, libconfig);
}
exports.specRender = specRender;
