import { AdvisorOptions, Advice } from '../advice-pipeline';
import EventEmitter from '@antv/event-emitter';
export interface Configs {
    theme?: string;
    data: any[];
}
/**
 * @public
 */
export interface AutoPlotOptions extends AdvisorOptions {
    theme?: string;
    feedback?: (container: HTMLDivElement) => void;
}
/**
 * @public
 */
export declare class AutoPlot extends EventEmitter {
    /**
     * 图表Schema列表
     */
    advices: Advice[];
    /**
     * 图表渲染容器
     */
    container: HTMLElement;
    /**
     * 图表唯一ID
     */
    uuid: string;
    /**
     * 当前激活(使用)的图表schema
     */
    current: number;
    /**
     * G2plot 图表实例
     */
    plot?: any;
    /**
     * 图表的配置
     */
    currentConfigs?: any;
    /**
     * 图表的类型
     */
    type?: string;
    private options;
    private data;
    private feedbackLayer;
    private feedback;
    /**
     * Constructor
     * @param container - 图表容器
     * @param data - 图表数据
     * @param options - 图表配置
     * @param oldAdvices - 同一个容器上次渲染的 advice列表
     * @param oldIndex - 同一个容器上次渲染的目标位置
     */
    constructor(container: HTMLElement, data: any[], options?: AutoPlotOptions, oldAdvices?: Advice[], oldIndex?: number, type?: string);
    /**
     * 渲染指定位置的schema
     * @param index - schema 的index
     */
    render(index: number): void;
    destroy(): void;
}
