import { AutoPlot } from './auto-plot';
import { DummyPlot } from './dummy-plot';
import { DevPanel } from './dev-panel';
import { Language } from '../i18n';
export declare class ConfigPanel {
    /**
     * config panel 的按钮
     */
    trigger: HTMLDivElement;
    /**
     * 图表容器
     */
    chartContainer: HTMLElement;
    /**
     * iframe
     */
    iframe: HTMLIFrameElement;
    /**
     * 是否以销毁
     */
    destroyed: boolean;
    /**
     * 容器关联的图表
     */
    plotInst: AutoPlot | DummyPlot;
    /**
     * 是不是需要拷贝数据的按钮
     */
    needCopyData: boolean;
    /**
     * 配置面板
     */
    panel?: DevPanel;
    /**
     * i18n
     */
    language: Language;
    private messageHandler;
    private mouseEnterHandler;
    private mouseLeaveHandler;
    constructor(plotInst: AutoPlot | DummyPlot, needCopyData: boolean, container: HTMLElement, language?: Language);
    initTrigger(): void;
    initIframe(): void;
    /**
     * 销毁实例
     */
    destroy(): void;
    /**
     * 响应面板类型变更
     */
    changeType(): void;
}
