"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DummyPlot = void 0;
var tslib_1 = require("tslib");
var util_1 = require("../util");
/**
 * @public
 */
var DummyPlot = /** @class */ (function () {
    function DummyPlot(container, data, config) {
        this.uuid = util_1.uuid();
        this.container = container;
        this.config = config;
        this.data = data;
        this.render();
    }
    DummyPlot.prototype.render = function () {
        var _this = this;
        var _a = this, config = _a.config, container = _a.container, data = _a.data;
        var type = config.type, configs = config.configs;
        this.currentConfigs = tslib_1.__assign(tslib_1.__assign({}, configs), { data: data });
        this.type = type;
        try {
            // @ts-ignore
            Promise.resolve().then(function () { return tslib_1.__importStar(require(/* webpackChunkName: "g2plot" */ '@antv/g2plot')); }).then(function (G2Plot) {
                // @ts-ignore
                _this.plot = new G2Plot[type](container, tslib_1.__assign(tslib_1.__assign({}, configs), { data: data }));
                _this.plot.render();
            });
        }
        catch (e) {
            throw new Error('current config is not supported by g2plot');
        }
    };
    DummyPlot.prototype.destroy = function () {
        if (this.plot && !this.plot.destroyed) {
            this.plot.destroy();
        }
    };
    return DummyPlot;
}());
exports.DummyPlot = DummyPlot;
