"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.KPIPlot = void 0;
var tslib_1 = require("tslib");
var util_1 = require("../util");
var style_1 = require("../style");
function generateCard(name, value) {
    var cardDom = document.createElement('div');
    cardDom.className = style_1.CLASS_PREFIX + "kpi-panel-card";
    var nameDom = document.createElement('div');
    nameDom.className = style_1.CLASS_PREFIX + "kpi-panel-card-name";
    cardDom.appendChild(nameDom);
    nameDom.innerText = name;
    var valueDOm = document.createElement('div');
    valueDOm.className = style_1.CLASS_PREFIX + "kpi-panel-card-value";
    valueDOm.innerText = value;
    cardDom.appendChild(valueDOm);
    return cardDom;
}
/**
 *  custom render kpi panel
 */
var KPIPlot = /** @class */ (function () {
    function KPIPlot(container, data) {
        this.container = container;
        this.data = data;
    }
    KPIPlot.prototype.render = function () {
        var e_1, _a;
        this.destroy();
        var wrapper = document.createElement('div');
        wrapper.className = style_1.CLASS_PREFIX + "kpi-panel";
        try {
            for (var _b = tslib_1.__values(Object.keys(this.data)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var key = _c.value;
                wrapper.appendChild(generateCard(key, this.data[key]));
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        this.container.appendChild(wrapper);
    };
    KPIPlot.prototype.update = function () { };
    KPIPlot.prototype.destroy = function () {
        util_1.removeAllChild(this.container);
    };
    return KPIPlot;
}());
exports.KPIPlot = KPIPlot;
