"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.intl = exports.setLanguage = exports.getLanguage = void 0;
var locales_1 = require("./locales");
var lodash_1 = require("lodash");
var defaultLanguage = undefined;
var transformLanguage = function (language) {
    // If the language starts with "zh", it is "zh-CN" by default,
    if (language && language === 'zh-CN')
        return language;
    // otherwise, it will be "en_US".
    return 'en-US';
};
exports.getLanguage = function () {
    if (defaultLanguage)
        return defaultLanguage;
    return transformLanguage(navigator.language);
};
// set the default language
exports.setLanguage = function (language) {
    defaultLanguage = language === 'zh-CN' || 'en-US' ? language : transformLanguage(navigator.language);
};
exports.intl = {
    get: function (key, language) {
        return lodash_1.get({ en_US: locales_1.en_US, zh_CN: locales_1.zh_CN }, [language ? transformLanguage(language).replace('-', '_') : exports.getLanguage().replace('-', '_'), key], key);
    },
};
