"use strict";
/**
 * 自动图表
 *
 * @example
 *
 * ```typescript
 *  const container = document.getElementById('mountNode');
 *  import { autoChart } from '@antv/chart-advisor';
 *
 *  const data = [
 *   {date: '2020/01/01', value: '666'},
 *   {date: '2020/01/02', value: '888'},
 *   ...
 *  ];
 *  autoChart(container, data);
 * ```
 *
 * @packageDocumentation
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.AutoChart = exports.autoChart = void 0;
var tslib_1 = require("tslib");
var auto_chart_1 = require("./auto-chart/auto-chart");
Object.defineProperty(exports, "AutoChart", { enumerable: true, get: function () { return auto_chart_1.AutoChart; } });
/**
 * 自动图表
 * @param container - 容器
 * @param data - 数据
 * @param options - 配置
 * @public
 */
function autoChart(container, data, options) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, auto_chart_1.AutoChart.create(container, data, options)];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.autoChart = autoChart;
var auto_plot_1 = require("./auto-chart/auto-plot");
Object.defineProperty(exports, "AutoPlot", { enumerable: true, get: function () { return auto_plot_1.AutoPlot; } });
var dummy_plot_1 = require("./auto-chart/dummy-plot");
Object.defineProperty(exports, "DummyPlot", { enumerable: true, get: function () { return dummy_plot_1.DummyPlot; } });
tslib_1.__exportStar(require("./advice-pipeline"), exports);
var rules_1 = require("./rules");
Object.defineProperty(exports, "initChartRules", { enumerable: true, get: function () { return rules_1.initChartRules; } });
Object.defineProperty(exports, "CHART_RULE_ID", { enumerable: true, get: function () { return rules_1.CHART_RULE_ID; } });
Object.defineProperty(exports, "Rule", { enumerable: true, get: function () { return rules_1.Rule; } });
var insight_1 = require("./insight");
Object.defineProperty(exports, "insightsFromData", { enumerable: true, get: function () { return insight_1.insightsFromData; } });
Object.defineProperty(exports, "insightsFromDataset", { enumerable: true, get: function () { return insight_1.insightsFromDataset; } });
var insightWorkers_1 = require("./insight/insightWorkers");
Object.defineProperty(exports, "INSIGHT_TYPES", { enumerable: true, get: function () { return insightWorkers_1.INSIGHT_TYPES; } });
Object.defineProperty(exports, "insightWorkers", { enumerable: true, get: function () { return insightWorkers_1.insightWorkers; } });
