"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getInsightSpaces = exports.workerCollection = exports.DefaultIWorker = void 0;
var tslib_1 = require("tslib");
var visual_insights_1 = require("visual-insights");
var utils_1 = require("./insightWorkers/utils");
exports.DefaultIWorker = visual_insights_1.Insight.DefaultIWorker;
exports.workerCollection = visual_insights_1.Insight.IntentionWorkerCollection.init();
exports.getInsightSpaces = function (props) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var dataSource, _fields, collection, _dimensions, _measures, _a, enableUniqueFields, fields, colFrame, dimensions, measures;
        return tslib_1.__generator(this, function (_b) {
            dataSource = props.dataSource, _fields = props.fields, collection = props.collection, _dimensions = props.dimensions, _measures = props.measures, _a = props.enableUniqueFields, enableUniqueFields = _a === void 0 ? true : _a;
            if (dataSource.length === 0)
                return [2 /*return*/, []];
            if (typeof _dimensions !== 'undefined' && typeof _measures !== 'undefined') {
                return [2 /*return*/, visual_insights_1.Insight.getVisSpaces({
                        dataSource: dataSource,
                        dimensions: _dimensions,
                        measures: _measures,
                        collection: collection,
                    })];
            }
            fields = typeof _fields === 'undefined' ? Object.keys(dataSource[0]) : _fields;
            colFrame = utils_1.rowDataToColumnFrame(dataSource);
            dimensions = colFrame.columnProps
                .filter(function (col) { return col.title !== null && fields.includes(col.title); })
                .filter(function (col) { return !(col.type === 'integer' || col.type === 'float'); })
                .filter(function (col) { return enableUniqueFields || !col.isUnique; })
                .map(function (col) { return col.title; });
            measures = colFrame.columnProps
                .filter(function (col) { return col.title !== null && fields.includes(col.title); })
                .filter(function (col) { return col.type === 'integer' || col.type === 'float'; })
                .map(function (col) { return col.title; });
            return [2 /*return*/, visual_insights_1.Insight.getVisSpaces({
                    dataSource: dataSource,
                    dimensions: dimensions,
                    measures: measures,
                    collection: collection,
                })];
        });
    });
};
