"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.insightsFromDataset = exports.insightsFromData = void 0;
var tslib_1 = require("tslib");
var dw_transform_1 = require("@antv/dw-transform");
var insightWorkers_1 = require("./insightWorkers");
/**
 * @public
 */
function insightsFromData(data) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var workers, allInsightsPack, allInsights;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    workers = Object.values(insightWorkers_1.insightWorkers);
                    return [4 /*yield*/, Promise.all(workers.map(function (worker) { return worker(data); }))];
                case 1:
                    allInsightsPack = _a.sent();
                    allInsights = [];
                    allInsightsPack.forEach(function (insights) {
                        allInsights = allInsights.concat(tslib_1.__spread(insights));
                    });
                    return [2 /*return*/, allInsights];
            }
        });
    });
}
exports.insightsFromData = insightsFromData;
/**
 * @public
 */
function insightsFromDataset(data, options) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var dataset, subDatasets, allInsightsPack, allInsights;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    dataset = new dw_transform_1.Dataset(data);
                    subDatasets = dataset.allSubspaceDataset(options);
                    return [4 /*yield*/, Promise.all(subDatasets.map(function (subDataset) { return insightsFromData(subDataset); }))];
                case 1:
                    allInsightsPack = _a.sent();
                    allInsights = [];
                    allInsightsPack.forEach(function (insights) {
                        allInsights = allInsights.concat(tslib_1.__spread(insights));
                    });
                    return [2 /*return*/, allInsights];
            }
        });
    });
}
exports.insightsFromDataset = insightsFromDataset;
