"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.correlationIW = void 0;
var utils_1 = require("./utils");
exports.correlationIW = function (data) {
    var THRESHOLD = 0.9;
    var insights = [];
    var _a = utils_1.rowDataToColumnFrame(data), columnProps = _a.columnProps, columns = _a.columns;
    for (var i = 0; i < columns.length; i++) {
        for (var j = i + 1; j < columns.length; j++) {
            if (columnProps[i].type !== null &&
                ['integer', 'float'].includes(columnProps[i].type) &&
                columnProps[j].type !== null &&
                ['integer', 'float'].includes(columnProps[j].type) &&
                Math.abs(utils_1.pearsonCorr(columns[i], columns[j])) > THRESHOLD) {
                insights.push({
                    type: 'Correlation',
                    description: "There is a correlation between '" + columnProps[i].title + "' and '" + columnProps[j].title + "'",
                    fields: [columnProps[i].title, columnProps[j].title],
                    present: {
                        purpose: ['Distribution'],
                        type: 'scatter_plot',
                        encoding: {
                            x: columnProps[i].title,
                            y: columnProps[j].title,
                        },
                        configs: { xAxis: { title: { visible: true } }, yAxis: { title: { visible: true } } },
                    },
                });
            }
        }
    }
    return insights;
};
