import { RowData } from '@antv/dw-transform';
import { Insight } from '..';
import { correlationIW } from './correlation';
import { monotonicityIW } from './monotonicity';
import { overallTrendsIW } from './overallTrends';
import { outlierIW } from './outlier';
import { trendIW as viTrendIW } from './vi-trend';
/**
 * @public
 */
export declare const INSIGHT_TYPES: ["Correlation", "Monotonicity", "MajorFactors", "OverallTrends", "CategoryOutliers", "TimeSeriesOutliers", "Seasonality", "ChangePoints"];
/**
 * @public
 */
export declare type InsightType = typeof INSIGHT_TYPES[number];
/**
 * @public
 */
export declare type Worker = (data: RowData[]) => Insight[] | Promise<Insight[]>;
/**
 * @public
 */
export declare const insightWorkers: Partial<Record<InsightType, Worker>>;
export { correlationIW, viTrendIW, monotonicityIW, overallTrendsIW, outlierIW };
