"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.outlierIW = exports.overallTrendsIW = exports.monotonicityIW = exports.viTrendIW = exports.correlationIW = exports.insightWorkers = exports.INSIGHT_TYPES = void 0;
var correlation_1 = require("./correlation");
Object.defineProperty(exports, "correlationIW", { enumerable: true, get: function () { return correlation_1.correlationIW; } });
var monotonicity_1 = require("./monotonicity");
Object.defineProperty(exports, "monotonicityIW", { enumerable: true, get: function () { return monotonicity_1.monotonicityIW; } });
var major_1 = require("./major");
var overallTrends_1 = require("./overallTrends");
Object.defineProperty(exports, "overallTrendsIW", { enumerable: true, get: function () { return overallTrends_1.overallTrendsIW; } });
var outlier_1 = require("./outlier");
Object.defineProperty(exports, "outlierIW", { enumerable: true, get: function () { return outlier_1.outlierIW; } });
var vi_trend_1 = require("./vi-trend");
Object.defineProperty(exports, "viTrendIW", { enumerable: true, get: function () { return vi_trend_1.trendIW; } });
var tuple = function () {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    return args;
};
/**
 * @public
 */
exports.INSIGHT_TYPES = tuple('Correlation', 'Monotonicity', 'MajorFactors', 'OverallTrends', 'CategoryOutliers', 
// todo...
'TimeSeriesOutliers', 'Seasonality', 'ChangePoints');
/**
 * @public
 */
exports.insightWorkers = {
    Correlation: correlation_1.correlationIW,
    Monotonicity: monotonicity_1.monotonicityIW,
    MajorFactors: major_1.majorFactorsIW,
    OverallTrends: overallTrends_1.overallTrendsIW,
    CategoryOutliers: outlier_1.outlierIW,
};
