import { RowData } from '@antv/dw-transform';
import { Insight as VisualInsight } from 'visual-insights';
import { TypeSpecifics, FieldInfo } from '@antv/dw-analyzer';
import { Insight } from '..';
import { Worker } from '.';
export declare function pearsonCorr(d1: number[], d2: number[]): number;
declare type Column = Array<string | number | null>;
interface ColumnProp {
    title: string;
    type: TypeSpecifics | null;
    isUnique?: boolean;
    isTime?: boolean;
    isInterval?: boolean;
    isOrdinal?: boolean;
    fieldInfo?: FieldInfo;
}
interface ColumnFrame {
    columnProps: ColumnProp[];
    columns: Column[];
}
export declare function rowDataToColumnFrame(rows: RowData[]): ColumnFrame;
export declare function columnsToRowData(columns: Column[], titles: string[]): RowData[];
export declare function insightSpaceToInsight(space: InsightSpace): Insight;
declare type VisualInsightWorkerID = VisualInsight.DefaultIWorker;
declare type InsightSpace = VisualInsight.InsightSpace;
export declare function visualInsightWorkerToAVAWorker(viWorkerId: VisualInsightWorkerID): Worker;
export declare function isMonotonicInc(array: number[]): boolean;
export declare function isMonotonicDec(array: number[]): boolean;
export declare function normalizeArray(array: number[]): number[];
export declare function outliersFilters(dataProps: FieldInfo[]): Function[];
export {};
