"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Rule = exports.CHART_RULE_ID = void 0;
/**
 * @public
 */
exports.CHART_RULE_ID = [
    'data-check',
    'data-field-qty',
    'no-redundant-field',
    'purpose-check',
    'series-qty-limit',
    'bar-series-qty',
    'line-field-time-ordinal',
    'landscape-or-portrait',
    'diff-pie-sector',
    'nominal-enum-combinatorial',
    'limit-series',
    'aggregation-single-row',
    'all-can-be-table',
];
/**
 * @public
 */
var Rule = /** @class */ (function () {
    function Rule(id, hardOrSoft, specChartTypes, weight, validator) {
        this._id = id;
        this._hardOrSoft = hardOrSoft;
        this._specChartTypes = specChartTypes;
        this._weight = weight;
        this.validator = validator;
    }
    Object.defineProperty(Rule.prototype, "id", {
        get: function () {
            return this._id;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Rule.prototype, "hardOrSoft", {
        get: function () {
            return this._hardOrSoft;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Rule.prototype, "specChartTypes", {
        get: function () {
            return this._specChartTypes;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Rule.prototype, "weight", {
        get: function () {
            return this._weight;
        },
        enumerable: false,
        configurable: true
    });
    Rule.prototype.toString = function () {
        return "RULE: " + this._id + "^" + this._hardOrSoft + "^" + this._specChartTypes.toString() + "^*" + this.weight;
    };
    Rule.prototype.check = function (args) {
        var weight = this._hardOrSoft === 'SOFT' ? (args === null || args === void 0 ? void 0 : args.weight) || this._weight : this._weight;
        return this.validator(args) * weight;
    };
    return Rule;
}());
exports.Rule = Rule;
