"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DesignRules = void 0;
var designRule_1 = require("./concepts/designRule");
exports.DesignRules = [
    new designRule_1.DesignRule('x-axis-line-fading', ['line_chart'], function (dataProps, chartTypeSpec) {
        var _a;
        if (((_a = chartTypeSpec.encoding.y) === null || _a === void 0 ? void 0 : _a.type) === 'quantitative') {
            var fieldInfo = dataProps.find(function (item) { var _a; return item.name === ((_a = chartTypeSpec.encoding.y) === null || _a === void 0 ? void 0 : _a.field); });
            if (fieldInfo) {
                var range = fieldInfo.maximum - fieldInfo.minimum;
                if (fieldInfo.minimum && fieldInfo.maximum && range < (fieldInfo.maximum * 2) / 3) {
                    var yScaleMin = Math.floor(fieldInfo.minimum - range / 5);
                    return {
                        x: {
                            ticks: false,
                            domain: false,
                        },
                        y: {
                            scale: {
                                domainMin: yScaleMin > 0 ? yScaleMin : 0,
                            },
                        },
                    };
                }
            }
        }
        return {};
    }),
];
