"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.removeAllChild = exports.DEFAULT_FEEDBACK = exports.createLayer = exports.translate = exports.getPosition = exports.getElementDisplay = exports.uuid = void 0;
var style_1 = require("./style");
var advice_pipeline_1 = require("./advice-pipeline");
/**
 * 随机生成一个唯一ID
 */
function uuid() {
    return "" + 'xxxx-xxxx-xxxx'.replace(/x/g, function () { return ((Math.random() * 16) | (0 & 0x3)).toString(16); });
}
exports.uuid = uuid;
function getElementDisplay(item) {
    return getComputedStyle(item, null).display;
}
exports.getElementDisplay = getElementDisplay;
function getPosition(target) {
    var _a = target.getBoundingClientRect(), top = _a.top, left = _a.left, right = _a.right;
    return {
        top: top + window.scrollY,
        left: left + window.scrollX,
        right: right + window.scrollX,
    };
}
exports.getPosition = getPosition;
/**
 * @deprecated
 * when config panel rebuild
 */
function translate(term) {
    return advice_pipeline_1.G2PLOT_TYPE_MAPPING[term] || term;
}
exports.translate = translate;
function createLayer(container, classname) {
    if (!['relative', 'absolute', 'fixed'].includes(getComputedStyle(container).position)) {
        container.style.position = 'relative';
    }
    var layer = document.createElement('div');
    layer.style.height = '100%';
    layer.style.width = '100%';
    layer.style.position = 'absolute';
    layer.style.top = '0px';
    layer.style.left = '0px';
    layer.style.pointerEvents = 'none';
    layer.style.boxSizing = 'border-box';
    if (classname)
        layer.className = classname;
    container.appendChild(layer);
    return layer;
}
exports.createLayer = createLayer;
function DEFAULT_FEEDBACK(feedback) {
    return function fn(container) {
        var content = document.createElement('div');
        content.className = style_1.CLASS_PREFIX + "no_data_content";
        content.innerHTML = "\n    <div style=\"margin-bottom: 16px;\">\n      <img src=\"https://gw.alipayobjects.com/zos/basement_prod/9a59280d-8f23-4234-b5cf-02956a91b6ff.svg\" />\n    </div>\n    <div>" + feedback + "</div>\n  ";
        container.appendChild(content);
    };
}
exports.DEFAULT_FEEDBACK = DEFAULT_FEEDBACK;
/**
 * remove all children node in specific dom
 * @param dom HTMLElement
 */
function removeAllChild(dom) {
    while (dom.firstChild) {
        dom.removeChild(dom.firstChild);
    }
}
exports.removeAllChild = removeAllChild;
